﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace xixunDemo
{
    unsafe class XiXunLedProgram
    {
        public XiXunLedProgram()
        {

        }
        const System.Int32 ATT_BUFF_SIZE=1024;
        // ----------------- 基础元素 -----------------//
        //文本文件类型 --12--
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TextFileAttribute{
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//文本文件自定义名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsTextFilePath;//文本文件文件路径名
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsTextFont;//字体名
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackground;//背景图片文件
            public System.Int32 nBackColor;//背景色
            public System.Int32 nTextFontStyle;//字体风格(粗体0x4,斜体0x2,下划线0x1)
            public System.Int32 nSpecialEffects;//特技类型
            public System.Int32 nSpecialEffectSpeed;//特技速度
            public System.Int32 nSpecialEffectDuration;//停留时间
            public System.Int32 nTextLineSpace;//行距
            public System.Int32 nViewMode;//显示模式,保留
            public System.Int32 nVerPosType;//0垂直居中,1垂直靠上,2垂直靠下
            public System.Int32 nFontWeigth;
            public System.Int32 nTextColor;
        }
	
        //文本类型 -- 6 --
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TextAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//文本自定义名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsText;//文本内容
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFont;//字体
            public System.Int32 nFontWeight;//字体大小
            public System.Int32 nTextColor;//字体颜色
            public System.Int32 nTextStyle;//字体风格(粗体0x4,斜体0x2,下划线0x1)
        }

        //图片类型 --- 9 ---
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct PictureAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//唯一标识名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFilePath;//文件路径名
            public System.Int32 nViewMode;//显示模式,0:普通居中1:缩放2:拉伸3:平铺
            public System.Int32 nBackColor;//背景色
            public System.Int32 nSpecialEffects;//进场特技
            public System.Int32 nSpecialEffectSpeed;//进场特技速度
            public System.Int32 nSpecialEffectDuration;//停留时间
            public System.Int32 nFinishSpecialEffects;//出场特技
            public System.Int32 nFinishSpecialEffectSpeed;//出场特技速度
        }

        //视频类型-- 6
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct VideoAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//唯一标识名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFilePath;//文件路径名
            public System.Int32 nPlayLoopCount;//循环次数
            public System.Int32 nBackColor;//背景色
            public System.Int32 nVideoWidth;//视频宽度
            public System.Int32 nVideoHeight;//视频高度
        }

        //GIF类型 ---5
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct GIFAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//唯一标识名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFilePath;//文件路径名
            public System.Int32 nBackColor;//循环次数
            public System.Int32 nSpecialEffects;//显示模式,0:普通居中1:缩放2:拉伸3:平铺
            public System.Int32 nPlayLoopCount;//循环次数
        }

        //RTF类型 -- 10
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct RTFAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//唯一标识名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFilePath;//文件路径名
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackground;//背景图片
            public System.Int32 nBackColor;//背景色
            public System.Int32 nSpecialEffects;//特技类型
            public System.Int32 nSpecialEffectSpeed;//特技速度
            public System.Int32 nSpecialEffectDuration;//停留时间
            public System.Int32 nLineSpace;//行距
            public System.Int32 nVerPosType;//0垂直居中,1垂直靠上,2垂直靠下
            public System.Int32 nDisplayType;//显示类型，保留
        }

        //Flash类型 -- 9
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct FlashAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;//唯一标识名称
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFilePath;//文件路径名
            public System.Int32 nBackColor;//背景色
            public System.Int32 nFlashWidth;//宽度
            public System.Int32 nFlashHeight;//高度
            public System.Int32 nFrameRate;//帧率
            public System.Int32 nStartFrame;//起始帧
            public System.Int32 nFinishFrame;//结束帧
            public System.Int32 nPlayLoopCount;//循环次数
        }
        // ------------------------------------------//
        
        //节目属性 -- 13
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct ProgramAttribute{
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsVersion;//版本
            public System.Int32 nDirectionX;//节目在计算机屏幕上预览窗口的起始x坐标
            public System.Int32 nDirectionY;//节目在计算机屏幕上预览窗口的起始y坐标
            public System.Int32 nScreenWidth;//节目宽度
            public System.Int32 nScreenHeight;//节目高度
            public System.Int32 nCommunicationType;//通讯类型，0:网络,1:串口,2:U盘,3:GPRS,4:数据中心服务器,5:FTP方式
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsIPAddress;//IP地址
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsLanguage;//语言类型
            public System.Int32 nPort;//网络端口或串口号
            public System.Int32 nBaudrate;//波特率
            public System.Int32 nUSBMode;//U盘使用模式,0:更新节目,1:扩展存储
            public byte bFullScreen;//是否全屏,保留
            public byte bTextSmooth;//是否字体光滑,保留
        }

        //Page属性 -- 7
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct PageAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsPageName;//节目页唯一标识
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图片
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsPageVariantName;//背景图片
            public System.Int32 nWindowAmount;//窗口数目
            public System.Int32 nBackgroundColor;//背景色
            public System.Int32 nPlayDuration;//播放时间
            public byte bWaitFinish;//等待节目播放完毕,true:该节目页的内容全部播放超过一次则节目页结束,false:按播放时间播放节目页，
        }

        //FileWindow属性 -- 8
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct FileWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图片
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
        }

        //文本窗属性 --8--
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TextWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            public System.Int32 nWindowBackColor;//背景色
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
        }

        //单行文本-- 10
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct SingLineTextAttribute
        {
            public System.Int32 nSpecialEffects;//特技
            public System.Int32 nSpecialEffectSpeed;//特技速度
            public System.Int32 nSpecialEffectDuration;//停留时间
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图片
            public byte bPictureUseasIcon;//true:背景图片作为logo,false:背景图片作为背景
            public System.Int32 nVerticalOffset;//垂直偏移
            public System.Int32 nTextSpace;//字间距
            public System.Int32 nTextRotaion;//0:不旋转,1:旋转90度,2:旋转180度,3:旋转270度
            public System.Int32 nTextStyle;//字体风格(粗体0x4,斜体0x2,下划线0x1)
            public System.Int32 nTextStyleColor;//字体颜色
        }

        //多行文本-- 9
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct MultiLineTextAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsTextName;//文本唯一标识
            public System.Int32 nTextHorizonAligning;//0:左对齐,1:右对齐,2:居中对齐,3两端对齐
            public System.Int32 nTextVerticalAligning;//0垂直居中,1垂直靠上,2垂直靠下
            public System.Int32 nSpecialEffects;//特技
            public System.Int32 nSpecialEffectDuration;//停留时间
            public System.Int32 nSpecialEffectSpeed;//特技速度
            public System.Int32 nBackgroundColor;//背景色
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPicturePath;//背景图片
            public System.Int32 nTextSpace;//字间距
            public System.Int32 nLineSpace;//行距
        }


        //表格窗属性 // -- 8
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TableWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nWindowBackColor;//背景色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
        }

        //表格属性 -- 10
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TableAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsTableName;//表格唯一标识
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFilePath;//文件路径名
            public System.Int32 nRowAmount;//行数
            public System.Int32 nColumnAmount;//列数
            public System.Int32 nFixedRowAmount;//固定行数
            public System.Int32 nFixedColumnAmount;//固定列数
            public System.Int32 nGridLineColor;//表格颜色
            public System.Int32 nSpecialEffects;//特技
            public System.Int32 nSpecialEffectSpeed;//特技速度
            public System.Int32 nSpecialEffectDuration;//停留时间
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct DATE_TIME
        {
            public System.Int32 nYear;//年
            public System.Int32 nMonth;//月
            public System.Int32 nDay;//日
            public System.Int32 nHour;//时
            public System.Int32 nMinute;//分
            public System.Int32 nSecond;//秒
            public System.Int32 nWeek;  //星期
        }
        //计时窗属性 -- 16 ---
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct PeroidWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nWindowBackColor;//背景色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
            public DATE_TIME definiteTime;//日期时间结构
            public byte bShowDays;//是否显示天
            public byte bShowHours;//是否显示小时
            public byte bShowMinutes;//是否显示分钟
            public byte bShowSeconds;//是否显示秒
            public byte bShowMultiLine;//true:多行显示,false:单行显示
            public byte bUnsignedNumber;//是否显示负数
            public System.Int32 nTimerType; //正/倒计时
            public byte bMaxUnitOnly;
            public byte bMultiView;
            public byte bShowTimeUnit;
        }

        //数字时钟窗口属性 --29--
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct DigitalClockWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nWindowBackColor;//背景色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
            public System.Int32 nShowStyle;//显示类型,1:[2003-05-30],2:[05-30-2003],3:[30-05-2003],4:[2003/05/30],5:[05/30/2003],6:[30/05/2003],7:[2003年5月30日]
            public System.Int32 nHourStyle;//0:12小时制,1:24小时制
            public System.Int32 nYearStyle;//0:4位年,1:2位年
            public byte bShowYear;//是否显示年
            public byte bShowMonth;//是否显示月
            public byte bShowDay;//是否显示日
            public byte bShowLunarYear;//是否显示农历年
            public byte bShowLunarMonth;//是否显示农历月
            public byte bShowLunarDay;//是否显示农历日
            public byte bShowWeek;//是否显示星期
            public byte bShowHalfDay;//是否显示半日标记
            public byte bShowHour;//是否显示小时
            public byte bShowMinute;//是否显示分钟
            public byte bShowSecond;// 是否显示秒
            public byte bHourrateBefore;//true超前,false滞后
            public System.Int32 nHourrateDays;//超前滞后天数
            public System.Int32 nHourrateHours;//超前滞后小时
            public System.Int32 nHourrateMinutes;//超前滞后分
            public System.Int32 nHourrateSeconds;//超前滞后秒
            public System.Int32 nMultiLineStyle;//0:单行显示,1:多行显示
        }

        //模拟时钟窗口属性 ---25---
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct AnalogClockWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nWindowBackColor;//背景色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
            public System.Int32 nHourScaleColor;//时标颜色
            public System.Int32 nHourScaleSize;//时标大小
            public System.Int32 nHourScaleShape;//时标形状,0:圆形,1:方形,2:数字
            public System.Int32 nMinuteScaleColor;//分标颜色
            public System.Int32 nMinuteScaleSize;//分标大小
            public System.Int32 nMinuteScaleShape;//分标形状,0:圆形,1:方形
            public byte bShowDate;//是否显示日期
            public byte bLunarCalendar;//是否显示农历
            public System.Int32 nHourhandColor;//时针颜色
            public System.Int32 nMinutehandColor;//分针颜色
            public System.Int32 nSecondhandColor;//秒针颜色
            public System.Int32 nHourrateDays;//超前滞后天数
            public System.Int32 nHourrateHours;//超前滞后小时
            public System.Int32 nHourrateMinutes;//超前滞后分
            public System.Int32 nHourrateSeconds;//超前滞后秒
            public byte bHourrateBefore;//true超前,false滞后
            public System.Int32 nAnalogClockShape;  //表盘形状
            public byte bShowWeek;          //显示星期
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TemperatureHumidityWindowAttribute
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsWindowName;//窗口唯一标识
            public System.Int32 nWindowFrame;//边框
            public System.Int32 nWindowFrameColor;//边框颜色
            public System.Int32 nWindowBackColor;//背景色
            public System.Int32 nDirectionX;//窗口的起始x坐标
            public System.Int32 nDirectionY;//窗口的起始y坐标
            public System.Int32 nWindowWidth;//窗口宽度
            public System.Int32 nWindowHeight;//窗口高度
            public System.Int32 nFontWeight;//字体大小
            public System.Int32 nTextColor;//字体颜色
            public System.Int32 nFontStyle;//字体风格(粗体0x4,斜体0x2,下划线0x1)
            public System.Int32 nDegreeType;//温度类型,0:摄氏度,1:华氏度
            public System.Int32 nTempRegulate;//温度校正
            public System.Int32 nHumiRegulate;//湿度校正
            public byte bMultiLine;//0:单行显示,1:多行显示
            public byte bShowTemperature;//是否显示温度
            public byte bShowHumidity;//是否显示湿度
            public byte bShowTemperatureUnit;//是否显示温度单位
            public byte bShowHumidityUnit;//是否显示湿度单位
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsFont;//字体
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsTempTitle;//温度描述
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsHumiTitle;//湿度描述
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsHumidityUnit;//湿度单位
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsTemperatureUnit;//温度单位
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsBackgroundPath;//背景图片路径
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct BackgroundMusic
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsItemName;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = ATT_BUFF_SIZE)]
            public String wsMusicFilePath;
        }
        //页面约束
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct DateConstraint
        {
            public System.Int32 nStartYear;//开始年
            public System.Int32 nStartMonth;//开始月
            public System.Int32 nStartDay;//开始日
            public System.Int32 nEndYear;//结束年
            public System.Int32 nEndMonth;//结束月
            public System.Int32 nEndDay;//结束日
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct TimeConstraint
        {
            public System.Int32 nStartHour;//开始时
            public System.Int32 nStartMinute;//开始分
            public System.Int32 nStartSecond;//开始秒
            public System.Int32 nEndHour;//结束时
            public System.Int32 nEndMinute;//结束分
            public System.Int32 nEndSecond;//结束秒
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        public struct WeekConstraint
        {
            public byte bMonday;//星期一
            public byte bTuesday;//星期二
            public byte bWednesday;//星期三
            public byte bThursday;//星期四
            public byte bFriday;//星期五
            public byte bSaturday;//星期六
            public byte bSunday;//星期日
        }


        enum COMMUNICATION_TYPE{NETWORK=1, COMPORT, USBMODE};
        enum TEXT_STYLE{STANDARD=0, BOLD=0x4, ITALIC=0x2, UNDERLINE=0x1};
        enum VIEW_MODE{CENTER, ZOOM, STRETCH, TILING};
        enum TEXT_ROTATION{ROTATE_0, ROTATE_90, ROTATE_180, ROTATE_270};
        enum TEXT_ALIGNING{ALIGNING_NONE, ALIGNING_LEFT, ALIGNING_CENTER, ALIGNLING_RIGHT, ALIGNLING_UP, ALIGNLING_DOWN};
        enum SHAPE{SHAPE_ROUND, SHAPE_RECT};
        enum TIMER_STYLE{COUNT, COUNTDOWN};
        enum ERROR_VALUES{ERROR_PROGRAM_EXIST = 1, ERROR_PROGRAM_ATTR, ERROR_IN_PARAM, ERROR_OUT_PARAM, 
	        ERROR_PAGE_NAME, ERROR_EXIST_GLOBALPAGE, ERROR_WINDOW_NAME, 
	        ERROR_WINDOW_NAME_NOT_FOUND, ERROR_PAGE_NAME_NOT_FOUND, ERROR_ITEM_NAME, 
	        ERROR_PAGE_NAME_EXIST, ERROR_WINDOW_NAME_EXIST, ERROR_TABLE_NAME_EXIST,
	        ERROR_ITEM_NAME_EXIST, ERROR_ITEM_NAME_NOT_FOUND};
        enum _ENUM_ACTION
	        {
		        ENUM_TEXIAO_NO=0,
		        ENUM_TEXIAO_RADIO,
		        ENUM_TEXIAO_FG_UP,
		        ENUM_TEXIAO_FG_DOWN,
		        ENUM_TEXIAO_FG_LEFT,
		        ENUM_TEXIAO_FG_RIGHT,
		        ENUM_TEXIAO_FG_CORNER_RD,
		        ENUM_TEXIAO_FG_CORNER_LD,
		        ENUM_TEXIAO_FG_CORNER_RU,
		        ENUM_TEXIAO_FG_CORNER_LU,
		        ENUM_TEXIAO_FG_UD_IN,
		        ENUM_TEXIAO_FG_LR_IN,
		        ENUM_TEXIAO_FG_UD_OUT,
		        ENUM_TEXIAO_FG_LR_OUT,
		        ENUM_TEXIAO_FG_SZ_IN,
		        ENUM_TEXIAO_FG_SZ_OUT,
		        ENUM_TEXIAO_FG_OUT_INT,
		        ENUM_TEXIAO_FG_INT_OUT,
		        ENUM_TEXIAO_MOVEUP,
		        ENUM_TEXIAO_MOVEDOWN,
		        ENUM_TEXIAO_MOVELEFT,
		        ENUM_TEXIAO_MOVERIGHT,
		        ENUM_TEXIAO_MOVERIGHTDOWN,
		        ENUM_TEXIAO_MOVELEFTDOWN,
		        ENUM_TEXIAO_MOVERIGHTUP,
		        ENUM_TEXIAO_MOVELEFTUP,
		        STUNT_COVER_SLANT_TOP_LEFT			, // 左上角覆盖（斜）；
		        STUNT_COVER_SLANT_TOP_RIGHT			, // 右上角覆盖（斜）；
		        STUNT_COVER_SLANT_BOTTOM_LEFT		, // 左下角覆盖（斜）；
		        STUNT_COVER_SLANT_BOTTOM_RIGHT	, // 右下角覆盖（斜）；
		        STUNT_BLIND_HORIZONE				, // 水平百叶窗；每个窗口按8个页计算每页的宽度。
		        STUNT_BLIND_VERTICAL				, // 垂直百叶窗；每个窗口按8个页计算每页的宽度。
		        STUNT_MASAIC						, // 马赛克；每个马赛克块大小按8*8像素计算。
		        STUNT_CIRCLE_OUT				, // 旋出。
		        STUNT_CIRCLE_IN					, // 旋入。
		        STUNT_TURN_CIRCLE_LEFT_360			, // 左旋360度；
		        STUNT_TURN_CIRCLE_RIGHT_360			, // 右旋360度；
		        STUNT_TURN_CIRCLE_LEFT_180			, // 左旋180度；
		        STUNT_TURN_CIRCLE_RIGHT_180			, // 右旋180度；
		        STUNT_TURN_CIRCLE_LEFT_90			, // 左旋90度；
		        STUNT_TURN_CIRCLE_RIGHT_90			, // 右旋90度；
		        STUNT_SECTOR						, // 扇形。
		        STUNT_ZOOM_UP						, // 由小变大（上）；
		        STUNT_ZOOM_DOWN						, // 由小变大（下）；
		        STUNT_ZOOM_LEFT						, // 由小变大（左）；
		        STUNT_ZOOM_RIGHT					, // 由小变大（右）；
		        STUNT_ZOOM_CENTROL					, // 由小变大（中间）；
		        STUNT_ZOOM_TOP_LEFT					, // 由小变大（左上角）；
		        STUNT_ZOOM_TOP_RIGHT				, // 由小变大（右上角）；
		        STUNT_ZOOM_BOTTOM_LEFT				, // 由小变大（左下角）；
		        STUNT_ZOOM_BOTTOM_RIGHT				, // 由小变大（左下角）；
		        STUNT_STUNT_COVER_RHOMBUS_IN		, // 四周向中间（菱形）；
		        STUNT_STUNT_COVER_RHOMBUS_OUT		, // 中间向四周（菱形）；
		        STUNT_STUNT_COVER_CIRCLE_IN			, // 四周向中间（圆形）；
		        STUNT_STUNT_COVER_CIRCLE_OUT		, // 中间向四周（圆形）；
		        STUNT_MERGE_HORIZONE				, // 水平合并。
		        STUNT_MERGE_VERTICAL				, // 垂直合并。
		        STUNT_CHEQURE_HORIZONE				, // 水平棋盘。
		        STUNT_CHEQURE_VERTICAL				, // 垂直棋盘。
		        STUNT_GLINT_HORIZONE				, // 水平闪动。
		        STUNT_GLINT_VERTICAL				, // 垂直闪动。
		        STUNT_INTERSECT_HORIZONE			, // 水平交叉。
		        STUNT_INTERSECT_VERTICAL			, // 垂直交叉。
		        STUNT_SNOW							, // 飘雪。
		        STUNT_FALLOW_DOWN					, // 下落
		        STUNT_GILNT					, // 闪烁，闪烁次数可以定义，计算机软件默认3次，0为永久闪烁。
		        STUNT_AGGLOMERTION_UP				, // 向上聚结。
		        STUNT_AGGLOMERTION_DOWN				, // 向下聚结。
		        STUNT_AGGLOMERTION_LEFT				, // 向左聚结。
		        STUNT_AGGLOMERTION_RIGHT			, // 向右聚结。
		        STUNT_LASER_UP						, // 向上镭射。
		        STUNT_LASER_DOWN					, // 向下镭射。
		        STUNT_LASER_LEFT					, // 向左镭射。
		        STUNT_LASER_RIGHT					, // 向右镭射。
		        STUNT_STRETCH_UP					, // 向上拉伸。
		        STUNT_STRETCH_DOWN					, // 向下拉伸。
		        STUNT_STRETCH_LEFT					, // 向左拉伸。
		        STUNT_STRETCH_RIGHT					, // 向右拉伸。
		        STUNT_CENTROL_MOVE_OUT				, // 中间移出。
		        STUNT_GRADUAL_CHANGE				, // 渐变效果；图像亮度从0~255按16步进变化。无灰度卡时无此选项。
		        STUNT_BANMATIAO_HORIZONE			,//斑马条水平
		        STUNT_BANMATIAO_VERTICAL			,//斑马条竖直
		        STUNT_MASAIC_SMALL						, // 马赛克；每个马赛克块大小按8*8像素计算。
		        STUNT_STUNT_SCROLL_LEFT			, // 向左连续移动；
		        STUNT_STUNT_SCROLL_UP			, // 向上连续移动；；
		        STUNT_STUNT_SCROLL_RIGHT			, // 向右连续移动；
		        STUNT_STUNT_SCROLL_DOWN			, // 向下连续移动；；
		        ENUM_TEXIAO_NUMBER,
	        };
        //接口初始化和释放----------------------------------------------------------------------//
        //[DllImport("XiXunLedProgram.dll")]
        //public static extern void CI_InitDLL();

        [DllImport("XiXunLedProgram.dll")]
        private static extern void CI_InitDLL();
        public void Call_CI_InitDLL()
        {
            CI_InitDLL();
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern void CI_UnInitDLL();
        public void Call_CI_UnInitDLL()
        {
            CI_UnInitDLL();
        }
        //---- Proram --------------------------------------------------------------------------//
        //通过xml文件路径加载一个已有的节目
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_LoadProgram([MarshalAs(UnmanagedType.LPWStr)]String xmlFile);
        public void Call_CI_LoadProgram([MarshalAs(UnmanagedType.LPWStr)]String xmlFile)
        {
            CI_LoadProgram(xmlFile);
        }

        [DllImport("XiXunLedProgram.dll")]
        private static extern void CI_SaveProgram([MarshalAs(UnmanagedType.LPWStr)]String xmlFile);
        public void Call_CI_SaveProgram([MarshalAs(UnmanagedType.LPWStr)]String xmlFile)
        {
            CI_LoadProgram(xmlFile);
        }
        //新建一个节目,填充节目属性(节目页的数量根据创建的page数量自动更新
        [DllImport("XiXunLedProgram.dll")]
        private static extern void CI_CreateProgram(ref ProgramAttribute pAttr);
        public void Call_CI_CreateProgram(ref ProgramAttribute pAttr)
        {
            CI_CreateProgram(ref pAttr);
        }
        //获得和设置节目属性
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_GetProgramAttribute(ref ProgramAttribute pAttr);
        public byte Call_CI_GetProgramAttribute(ref ProgramAttribute pAttr)
        {
            return CI_GetProgramAttribute(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_SetProgramAttribute(ref ProgramAttribute pAttr);
        //--------------------------------------------------------------------------------------//
        public byte Call_CI_SetProgramAttribute(ref ProgramAttribute pAttr)
        {
            return CI_SetProgramAttribute(ref pAttr);
        }
        //---- Pages + Page --------------------------------------------------------------------//
        //新建一个节目页,填充节目页属性,返回节目页名称.（函数自动为每个节目生成windows节点）
        [DllImport("XiXunLedProgram.dll")]
        private static extern String CI_CreatePage(ref PageAttribute pAttr);
        public String Call_CI_CreatePage(ref PageAttribute pAttr)
        {
            return CI_CreatePage(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_RemovePage([MarshalAs(UnmanagedType.LPWStr)]String wsPageName);
        public byte Call_CI_RemovePage([MarshalAs(UnmanagedType.LPWStr)]String wsPageName)
        {
            return CI_RemovePage(wsPageName);
        }
        //获得和设置节目页属性
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_GetPageAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, ref PageAttribute pAttr);
        public byte Call_CI_GetPageAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, ref PageAttribute pAttr)
        {
            return CI_GetPageAttribute(wsPageName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_SetPageAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, ref PageAttribute pAttr);
        public byte Call_CI_SetPageAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, ref PageAttribute pAttr)
        {
            return CI_SetPageAttribute(wsPageName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddBackgroundMusic([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsMusicPath);
        public byte Call_CI_AddBackgroundMusic([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsMusicPath)
        {
            return CI_AddBackgroundMusic(wsPageName, wsMusicPath);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_RemoveBackgroundMusic([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsMusicPath);
        public byte Call_CI_RemoveBackgroundMusic([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsMusicPath)
        {
            return CI_RemoveBackgroundMusic(wsPageName, wsMusicPath);
        }
        //新建一个全局节目页，填充节目页属性，返回节目页名称（该函数只允许调用一次）
        [DllImport("XiXunLedProgram.dll")]
        private static extern char[] CI_CreateGlobalPage(ref PageAttribute pAttr);
        public char[] Call_CI_CreateGlobalPage(ref PageAttribute pAttr)
        {
            return CI_CreateGlobalPage(ref pAttr);
        }
        //移除全局节目页可以调用Removepage（）
        //获得和设置属性调用CI_GetPageAttribute和CI_SetPageAttribute
        //获取和设置节目页限制
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddConstraint([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName,
		        ref DateConstraint ds, ref TimeConstraint ts, ref WeekConstraint ws);
        public byte Call_CI_AddConstraint([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName,
                ref DateConstraint ds, ref TimeConstraint ts, ref WeekConstraint ws)
        {
            return CI_AddConstraint(wsPageName, wsItemName, ref ds, ref ts, ref ws);
        }
        //移除一个节目页播放限
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_RemoveConstraint([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName);
        //--------------------------------------------------------------------------------------//
        public byte Call_CI_RemoveConstraint([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName)
        {
            return CI_RemoveConstraint(wsPageName, wsItemName);
        }
        //---- Windows + FileWindow ----------------------------------------------------------------------//
        //新建一个文件窗，需要两个输入参数：属主节目页名称和文件窗属性
        [DllImport("XiXunLedProgram.dll")]
        private static extern char[] CI_CreateFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, ref FileWindowAttribute pAttr);
        public char[] Call_CI_CreateFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, ref FileWindowAttribute pAttr)
        {
            return CI_CreateFileWindow(wsPageName, ref pAttr);
        }
        //获得和设置文件窗口属性
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_GetFileWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref FileWindowAttribute pAttr);
        public byte Call_CI_GetFileWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref FileWindowAttribute pAttr)
        {
            return CI_GetFileWindowAttribute(wsPageName, wsWindowName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_SetFileWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref FileWindowAttribute pAttr);
        public byte Call_CI_SetFileWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref FileWindowAttribute pAttr)
        {
            return CI_SetFileWindowAttribute(wsPageName, wsWindowName, ref pAttr);
        }
        //移除文件窗口
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_RemoveWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName);
        public byte Call_CI_RemoveWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName)
        {
            return CI_RemoveWindow(wsPageName, wsWindowName);
        }
        //向文件窗中添加素材
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddImageToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref PictureAttribute pAttr);
        public byte Call_CI_AddImageToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref PictureAttribute pAttr)
        {
            return CI_AddImageToFileWindow(wsPageName, wsWindowName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddTextToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref TextFileAttribute pAttr);
        public byte Call_CI_AddTextToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref TextFileAttribute pAttr)
        {
            return CI_AddTextToFileWindow(wsPageName, wsWindowName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddVideoToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref VideoAttribute pAttr);
        public byte Call_CI_AddVideoToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref VideoAttribute pAttr)
        {
            return CI_AddVideoToFileWindow(wsPageName, wsWindowName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddGIFToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref GIFAttribute pAttr);
        public byte Call_CI_AddGIFToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref GIFAttribute pAttr)
        {
            return CI_AddGIFToFileWindow(wsPageName, wsWindowName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_AddRTFToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref RTFAttribute pAttr);
        public byte Call_CI_AddRTFToFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref RTFAttribute pAttr)
        {
            return CI_AddRTFToFileWindow(wsPageName, wsWindowName, ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        private static extern byte CI_RemoveItemFromFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName);
        //------------------------------------------------------------------------------------------------//
        public byte Call_CI_RemoveItemFromFileWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName)
        {
            return CI_RemoveItemFromFileWindow(wsPageName, wsWindowName, wsItemName);
        }

        //---- windows + SingLineTextWindow --------------------------------------------------------------//
        //创建一个单行文本窗,返回窗口名称
        [DllImport("XiXunLedProgram.dll")]
        public static extern char[] CI_CreateSinglineTextWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
								        ref TextWindowAttribute pWindow,
								        ref SingLineTextAttribute pAttr,
								        ref TextAttribute pText);
        public char[] Call_CI_CreateSinglineTextWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        ref TextWindowAttribute pWindow,
                                        ref SingLineTextAttribute pAttr,
                                        ref TextAttribute pText)
        {
            return CI_CreateSinglineTextWindow(wsPageName, ref pWindow,
                                        ref pAttr,
                                        ref pText);
        }
        //移除一个SinglineTextWindow,同CI_RemoveWindow()
        //XIXUNLEDPROGRAM_API byte CI_RemoveWindow([MarshalAs(UnmanagedType.LPWStr)]String wsWindowName);
        //获得和设置TextWindow的属性和文字
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_GetSinglineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, 
								        ref TextWindowAttribute pWindow,
								        ref SingLineTextAttribute pAttr,
								        ref TextAttribute pText);
        public byte Call_CI_GetSinglineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, 
                                        ref TextWindowAttribute pWindow,
                                        ref SingLineTextAttribute pAttr,
                                        ref TextAttribute pText)
        {
            return CI_GetSinglineTextAttribute(wsPageName, wsWindowName,
                                        ref pWindow,
                                        ref pAttr,
                                        ref pText);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_SetSinglineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, 
								        ref TextWindowAttribute pWindow,
								        ref SingLineTextAttribute pAttr,
								        ref TextAttribute pText);
        public byte Call_CI_SetSinglineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                        ref TextWindowAttribute pWindow,
                                        ref SingLineTextAttribute pAttr,
                                        ref TextAttribute pText)
        {
            return CI_SetSinglineTextAttribute(wsPageName, wsWindowName,
                                        ref pWindow,
                                        ref pAttr,
                                        ref pText);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_GetText([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, 
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, ref TextAttribute pText);
        public byte Call_CI_GetText([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, ref TextAttribute pText)
        {
            return CI_GetText(wsPageName,
                                       wsWindowName, 
                                       wsItemName, ref pText);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_SetText([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, ref TextAttribute pText);
        public byte Call_CI_SetText([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, ref TextAttribute pText)
        {
            return CI_SetText(wsPageName,
                                       wsWindowName,
                                       wsItemName, ref pText);
        }        //-------------------------------------------------------------------------------------------------//
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_GetTextWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref TextWindowAttribute pAttr);
        public byte Call_CI_GetTextWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref TextWindowAttribute pAttr)
        {
            return CI_GetTextWindowAttribute( wsPageName, wsWindowName, ref pAttr);
        }        //-------------------------------------------------------------------------------------------------//
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_SetTextWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref TextWindowAttribute pAttr);
        public byte Call_CI_SetTextWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, ref TextWindowAttribute pAttr)
        {
            return CI_SetTextWindowAttribute(wsPageName, wsWindowName, ref pAttr);
        }        //-------------------------------------------------------------------------------------------------//
        //---- windows + MultiLineTextwindow --------------------------------------------------------------//
        //创建一个多行文本窗,返回窗口名称
        [DllImport("XiXunLedProgram.dll")]
        public static extern char[] CI_CreateMultilineTextWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
								        ref TextWindowAttribute pWindow);
        public char[] Call_CI_CreateMultilineTextWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
								        ref TextWindowAttribute pWindow)
        {
            return CI_CreateMultilineTextWindow(wsPageName,ref pWindow);
        }        //-------------------------------------------------------------------------------------------------//
        //移除一MultilineTextWindow,同CI_RemoveWindow()
        //新增一个文本到多行文本窗中
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_AddMultiTextToWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, 
								        ref MultiLineTextAttribute pAttr, ref TextAttribute pText);
        public byte Call_CI_AddMultiTextToWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                        ref MultiLineTextAttribute pAttr, ref TextAttribute pText)
        {
            return CI_AddMultiTextToWindow(wsPageName, wsWindowName, 
								        ref pAttr, ref pText);
        }        //-------------------------------------------------------------------------------------------------//
        //获得和设置
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_GetMultilineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, ref TextWindowAttribute pWindow,
								        ref MultiLineTextAttribute pAttr, ref TextAttribute pText);
        public byte Call_CI_GetMultilineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                        [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, ref TextWindowAttribute pWindow,
                                        ref MultiLineTextAttribute pAttr, ref TextAttribute pText)
        {
            return CI_GetMultilineTextAttribute(wsPageName,wsWindowName,
                                        wsItemName, ref pWindow,
								        ref pAttr, ref pText);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_SetMultilineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName, 
								        ref MultiLineTextAttribute pAttr, ref TextAttribute pText);
        public byte Call_CI_SetMultilineTextAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName,
                                        ref MultiLineTextAttribute pAttr, ref TextAttribute pText)
        {
            return CI_SetMultilineTextAttribute(wsPageName, wsWindowName,wsItemName, 
								        ref pAttr, ref pText);
        }        //获得和设置Text同CI_GetText() and CI_SetText()
        //移除一行文字
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte CI_RemoveText([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName);
        //-------------------------------------------------------------------------------------------------//
        public byte Call_CI_RemoveText([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName, [MarshalAs(UnmanagedType.LPWStr)]String wsItemName)
        {
            return CI_RemoveText(wsPageName, wsWindowName,wsItemName);
        }        //获得和设置Text同CI_GetText() and CI_SetText()

 
        //---- windows + PeroidWindow ----------------------------------------------------------------------//
        //创建一个计时窗
        [DllImport("XiXunLedProgram.dll")]
        public static extern char []  CI_CreatePeroidWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, 
													        ref PeroidWindowAttribute pAttr,
													        ref DATE_TIME  pDt,
													        ref TextAttribute pTitle);
        public char[] Call_CI_CreatePeroidWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                                            ref PeroidWindowAttribute pAttr,
                                                            ref DATE_TIME pDt,
                                                            ref TextAttribute pTitle)
        {
            return CI_CreatePeroidWindow(wsPageName, 
													        ref pAttr,
													        ref pDt,
													        ref pTitle);
        }        //获得和设置Text同CI_GetText() and CI_SetText()
        //移除同CI_RemoveWindow（）
        //获得和设置PeroidWindow的属性
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_GetPeroidWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
													        ref PeroidWindowAttribute pAttr);
        public byte Call_CI_GetPeroidWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                            ref PeroidWindowAttribute pAttr)
        {
            return CI_GetPeroidWindowAttribute(wsPageName, wsWindowName,ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_SetPeroidWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
													        ref PeroidWindowAttribute pAttr);
        public byte Call_CI_SetPeroidWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                           ref PeroidWindowAttribute pAttr)
        {
            return CI_SetPeroidWindowAttribute(wsPageName, wsWindowName, ref pAttr);
        }
        //获得和设置title 同CI_GetText() and CI_SetText()
        //--------------------------------------------------------------------------------------------------//

        //----- windows + ClockWindow ----------------------------------------------------------------------//
        //创建一个数字时钟窗
        [DllImport("XiXunLedProgram.dll")]
        public static extern char [] CI_CreateDigitalClockWindow(String wsPageName,ref DigitalClockWindowAttribute pAttr,ref TextAttribute pTitle);
        public char[] Call_CI_CreateDigitalClockWindow(String wsPageName,
                ref DigitalClockWindowAttribute pAttr, ref TextAttribute pTitle)
        {
            return CI_CreateDigitalClockWindow(wsPageName, 
		        ref pAttr, ref pTitle);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern char[] CI_CreateDigitalClockWindow(String wsPageName,ref DigitalClockWindowAttribute pAttr);
        public char[] Call_CI_CreateDigitalClockWindow(String wsPageName,
                ref DigitalClockWindowAttribute pAttr)
        {
            return CI_CreateDigitalClockWindow(wsPageName,ref pAttr);
        }
        //移除同CI_RemoveWindow（）

        //获得和设置数字时钟窗口的属性
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_GetDigitalClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
												        ref DigitalClockWindowAttribute pAttr);
        public byte Call_CI_GetDigitalClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                        ref DigitalClockWindowAttribute pAttr)
        {
            return CI_GetDigitalClockWindowAttribute(wsPageName, wsWindowName,
												        ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_SetDigitalClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
												        ref DigitalClockWindowAttribute pAttr);

        public byte Call_CI_SetDigitalClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                       ref DigitalClockWindowAttribute pAttr)
        {
            return CI_SetDigitalClockWindowAttribute(wsPageName, wsWindowName,
                                                        ref pAttr);
        }       //创建一个模拟时钟窗
        [DllImport("XiXunLedProgram.dll")]
        public static extern char []  CI_CreateAnalogClockWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, 
		        ref AnalogClockWindowAttribute pAttr, ref TextAttribute pTitle, 
		        ref TextAttribute pDateTitle, ref TextAttribute pWeekTitle);
        public char[] Call_CI_CreateAnalogClockWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
               ref AnalogClockWindowAttribute pAttr, ref TextAttribute pTitle,
               ref TextAttribute pDateTitle, ref TextAttribute pWeekTitle)
        {
            return CI_CreateAnalogClockWindow(wsPageName,
                ref  pAttr, ref pTitle,
                ref pDateTitle, ref pWeekTitle);
        }          //移除同CI_RemoveWindow（）

        //获得和设置模拟时钟窗口的属性
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_GetAnalogClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
												        ref AnalogClockWindowAttribute pAttr);
        public byte Call_CI_GetAnalogClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                        ref AnalogClockWindowAttribute pAttr)
        {
            return CI_GetAnalogClockWindowAttribute(wsPageName,wsWindowName,
												        ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_SetAnalogClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
												        ref AnalogClockWindowAttribute pAttr);

        public byte Call_CI_SetAnalogClockWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                        ref AnalogClockWindowAttribute pAttr)
        {
            return CI_SetAnalogClockWindowAttribute(wsPageName, wsWindowName,
                                                        ref pAttr);
        }
        //获得和设置title 同CI_GetText() and CI_SetText()
        //---------------------------------------------------------------------------------------------------//

        //---- windows + TempHumiWindow ---------------------------------------------------------------------//
        //创建一个温湿度窗
        [DllImport("XiXunLedProgram.dll")]
        public static extern char []  CI_CreateTempHumiWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
												        ref TemperatureHumidityWindowAttribute pAttr);
        public char[] Call_CI_CreateTempHumiWindow([MarshalAs(UnmanagedType.LPWStr)]String wsPageName,
                                                        ref TemperatureHumidityWindowAttribute pAttr)
        {
            return CI_CreateTempHumiWindow(wsPageName, ref pAttr);
        }       //移除同CI_RemoveWindow()
        //获得和设置TempHumiWindow的属性
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_GetTempHumiWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
												        ref TemperatureHumidityWindowAttribute pAttr);
        public byte Call_CI_GetTempHumiWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                        ref TemperatureHumidityWindowAttribute pAttr)
        {
            return CI_GetTempHumiWindowAttribute(wsPageName, wsWindowName,
												        ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_SetTempHumiWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
												        ref TemperatureHumidityWindowAttribute pAttr);
        public byte Call_CI_SetTempHumiWindowAttribute([MarshalAs(UnmanagedType.LPWStr)]String wsPageName, [MarshalAs(UnmanagedType.LPWStr)]String wsWindowName,
                                                       ref TemperatureHumidityWindowAttribute pAttr)
        {
            return CI_SetTempHumiWindowAttribute(wsPageName, wsWindowName,
                                                        ref pAttr);
        }       //---------------------------------------------------------------------------------------------------//

        //编译函数
        [DllImport("XiXunLedProgram.dll")]
        public static extern bool CI_CompileProgram([MarshalAs(UnmanagedType.LPWStr)]String wsXMLFile, [MarshalAs(UnmanagedType.LPWStr)]String wsSavePath);
        public bool Call_CI_CompileProgram([MarshalAs(UnmanagedType.LPWStr)]String wsXMLFile, [MarshalAs(UnmanagedType.LPWStr)]String wsSavePath)
        {
            return CI_CompileProgram(wsXMLFile , wsSavePath);
        }


        //初始化属性-----------------------------------------------------------------------------------------//
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitTextFile(ref TextFileAttribute pAttr);
        public void Call_CI_InitTextFile(ref TextFileAttribute pAttr)
        {
            CI_InitTextFile(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitText(ref TextAttribute pAttr);
        public void Call_CI_InitText(ref TextAttribute pAttr)
        {
            CI_InitText(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitPicture(ref PictureAttribute pAttr);
        public void Call_CI_InitPicture(ref PictureAttribute pAttr)
        {
            CI_InitPicture(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitVideo(ref VideoAttribute pAttr);
        public void Call_CI_InitVideo(ref VideoAttribute pAttr)
        {
            CI_InitVideo(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitGIF(ref GIFAttribute pAttr);
        public void Call_CI_InitGIF(ref GIFAttribute pAttr)
        {
            CI_InitGIF(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitRTF(ref RTFAttribute pAttr);
        public void Call_CI_InitRTF(ref RTFAttribute pAttr)
        {
            CI_InitRTF(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitProgram(ref ProgramAttribute pAttr);
        public void Call_CI_InitProgram(ref ProgramAttribute pAttr)
        {
            CI_InitProgram(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitPage(ref PageAttribute pAttr);
        public void Call_CI_InitPage(ref PageAttribute pAttr)
        {
            CI_InitPage(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitFileWindow(ref FileWindowAttribute pAttr);
        public void Call_CI_InitFileWindow(ref FileWindowAttribute pAttr)
        {
            CI_InitFileWindow(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitSinglineText(ref SingLineTextAttribute pAttr);
        public void Call_CI_InitSinglineText(ref SingLineTextAttribute pAttr)
        {
            CI_InitSinglineText(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitMultilineText(ref MultiLineTextAttribute pAttr);
        public void Call_CI_InitMultilineText(ref MultiLineTextAttribute pAttr)
        {
            CI_InitMultilineText(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitPeroidWindow(ref PeroidWindowAttribute pAttr);
        public void Call_CI_InitPeroidWindow(ref PeroidWindowAttribute pAttr)
        {
            CI_InitPeroidWindow(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitDigitalClockWindow(ref DigitalClockWindowAttribute pAttr);
        public void Call_CI_InitDigitalClockWindow(ref DigitalClockWindowAttribute pAttr)
        {
            CI_InitDigitalClockWindow(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitAnalogClockWindow(ref AnalogClockWindowAttribute pAttr);
        public void Call_CI_InitAnalogClockWindow(ref AnalogClockWindowAttribute pAttr)
        {
            CI_InitAnalogClockWindow(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitTempHumiWindow(ref TemperatureHumidityWindowAttribute pAttr);
        public void Call_CI_InitTempHumiWindow(ref TemperatureHumidityWindowAttribute pAttr)
        {
            CI_InitTempHumiWindow(ref pAttr);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_InitTextWindow(ref TextWindowAttribute pAttr);
        public void Call_CI_InitTextWindow(ref TextWindowAttribute pAttr)
        {
            CI_InitTextWindow(ref pAttr);
        }        //----------------------------------------------------------------------------------------------------//
        [DllImport("XiXunLedProgram.dll")]
        public static extern byte  CI_ValidateProgram([MarshalAs(UnmanagedType.LPWStr)]String pErrMsg, System.Int32 nMsgLength);
        public byte Call_CI_ValidateProgram([MarshalAs(UnmanagedType.LPWStr)]String pErrMsg, System.Int32 nMsgLength)
        {
            return CI_ValidateProgram(pErrMsg, nMsgLength);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern void  CI_SetLastError(System.Int32 nError);
        public void Call_CI_SetLastError(System.Int32 nError)
        {
            CI_SetLastError(nError);
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern System.Int32  CI_GetLastError();
        public System.Int32 Call_CI_GetLastError()
        {
           return  CI_GetLastError();
        }
        [DllImport("XiXunLedProgram.dll")]
        public static extern char []  CI_GetVersion();
        public char[] Call_CI_GetVersion()
        {
            return CI_GetVersion();
        }
    }
}
